
  #include <LiquidCrystal.h> // Подключаем библиотеку для работы LCD (ЖКИ)
  #define STOP_PIN  7 // выход сигнала индикатора разряда/стоп
  #define SIGN_PIN  6 //выход звукового сигнала
  #define R_PIN  A3 //кнопка вывода на ЖКИ сопротивления батереи
  #define U_PIN  A4 //вывод управления входным коммутатором
  float Vcc = 4.98; // опорное напряжения (напряжение питания микроконтроллера)
  float R = 0.033;  // сопротивление проводов
  float RI = 0.478; // сопротивление датчика тока
  float K1 = 1.065; // поправочный коэффициент первого интервала
  float K2 = 3.039; // поправочный коэффициент второго интервала
  float K = 0.0;
  LiquidCrystal lcd(13, 12, 11, 10,  9,  8); //  номера пинов, к которым подключен LCD в
                                               // порядке: RS   E DB4 DB5 DB6 DB7
     
    void setup() 
    {
      // Работа с экраном. Сообщаем ему число строк и столбцов. Опять же, вызывать pinMode не требуется:
      // функция begin сделает всё за нас
      lcd.begin(16, 2);
      pinMode(STOP_PIN, OUTPUT);
      pinMode(SIGN_PIN, OUTPUT);
      pinMode(U_PIN, OUTPUT);
      pinMode(R_PIN, INPUT_PULLUP); //подтягиваем вход к + питания     
     
     digitalWrite(STOP_PIN, LOW);
     digitalWrite(U_PIN, LOW);
     delay(100);
     float U = analogRead(A0) / 1024.0 * Vcc; //  напряжение батареи с нагрузкой
       if (U > 4.9)
       { K = K2;
       digitalWrite(U_PIN, HIGH);
       }
       else { K = K1;
       digitalWrite(U_PIN, LOW);
       }
     delay(100);   
             }
     
    void loop() 
    { 
    float UbI = analogRead(A0) / 1024.0 * Vcc * K; //  напряжение батареи с нагрузкой
     float Ut = analogRead(A1) / 1024.0 * Vcc * K; //  напряжение порога выключения
     float Ib = analogRead(A2) / 1024.0 * Vcc / RI; //  ток разряда
     float C = (Ib * millis() / 3600000); //расчет емкости в А*ч
     float Ub = UbI + (Ib * R); // напряжение батареи

      boolean R_PINUp = digitalRead(R_PIN); //проверка нажата ли кнопка вывода сопротивления
      if (R_PINUp) {
            // выводим информацию на LCD
      lcd.setCursor(0, 0);// устанавливаем курсор, колонку 0, строку 0
      // печатаем напряжение батареи
      lcd.print("Ub=");  
      lcd.print(Ub);  
      // печатаем напряжение напряжение выключения
      lcd.setCursor(0, 1); //устанавливаем курсор, колонка 9, строка 0
      lcd.print("Ut="); 
      lcd.print(Ut); 
      // печатаем ток разрядки
      lcd.setCursor(9, 1); //устанавливаем курсор, колонка 0, строка 1
      lcd.print("Ib=");  
      lcd.print(Ib);        
      // печатаем емкость
      lcd.setCursor(9, 0);//устанавливаем курсор, колонка 9, строка 1
      lcd.print("C="); 
      lcd.print(C);
           }

      else 
      {
      digitalWrite(STOP_PIN, HIGH);
      delay(100);
      float U0 = analogRead(A0) / 1024.0 * Vcc * K; //  напряжение батареи без нагрузки
      digitalWrite(STOP_PIN, LOW);
      delay(100);
      float UI = analogRead(A0) / 1024.0 * Vcc * K; //  напряжение батареи с нагрузкой
      float Ib = analogRead(A2) / 1024.0 * Vcc / RI; //  ток разряда
      float Rb = ((U0 - UI)/Ib) - R; // вычисляем сопротивление батареи
      
             // выводим информацию на LCD
      lcd.setCursor(0, 0);// устанавливаем курсор, колонку 0, строку 0
      // печатаем напряжение батареи
      lcd.print("U0=");  
      lcd.print(U0);  
      // печатаем напряжение выключения
      lcd.setCursor(0, 1); //устанавливаем курсор, колонка 9, строка 0
      lcd.print("Ut="); 
      lcd.print(Ut); 
      // печатаем ток разрядки
      lcd.setCursor(9, 1); //устанавливаем курсор, колонка 0, строка 1
      lcd.print("Ib=");  
      lcd.print(Ib);        
      // печатаем сопротивление
      lcd.setCursor(9, 0);//устанавливаем курсор, колонка 9, строка 1
      lcd.print("R="); 
      lcd.print(Rb); 
          }
       
          if (Ub < Ut) { //выключение нагрузки при достижении порогового напряжения
    tone(SIGN_PIN, 1000, 300);
    delay(1000);
    tone(SIGN_PIN, 1000, 300);
    delay(1000);
    tone(SIGN_PIN, 1000, 300);
    digitalWrite(STOP_PIN, HIGH);
    while(1);  
        
       }
}
     
   
     
     
       
       
         
       


   
     



